unit GenMenu;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, Forms, Controls, Graphics, Dialogs, StdCtrls,
  ExtCtrls, txQtFunc;

type

  { TGenMenuF }

  TGenMenuF = class(TForm)
    ListBox1: TListBox;
    Timer1: TTimer;
    procedure FormCloseQuery(Sender: TObject; var CanClose: boolean);
    procedure FormMouseLeave(Sender: TObject);
procedure FormShow(Sender: TObject);
    procedure ListBox1Click(Sender: TObject);
    procedure ListBox1MouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure ListBox1MouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure ListBox1SelectionChange(Sender: TObject; User: boolean);
    procedure Timer1StopTimer(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
  private
    { private declarations }
  public
    { public declarations }
    MRes : string;
    moving : boolean;
    tx_doClose : boolean;
  end; 

var
  GenMenuF: TGenMenuF;

implementation

{$R *.lfm}

uses MainUnit;

{ TGenMenuF }

procedure TGenMenuF.ListBox1SelectionChange(Sender: TObject; User: boolean);
begin
  if not User then
    MRes := '';
end;

procedure TGenMenuF.Timer1StopTimer(Sender: TObject);
begin

end;

procedure TGenMenuF.Timer1Timer(Sender: TObject);
begin
  Timer1.Enabled := False;
  if not moving then
    begin
      ModalResult := mrOk;
    end
  else
    begin
      ModalResult := mrNone;
      ListBox1.ItemIndex:=-1;
    end;
end;

procedure TGenMenuF.ListBox1Click(Sender: TObject);
begin
end;

procedure TGenMenuF.FormShow(Sender: TObject);
begin
  MRes := '';
  ListBox1.ItemIndex:=-1;
  if MainForm.Settings.AppOrientation = aoAuto then
    RotateApp(GenMenuF.Handle,aoAuto);
  if MainForm.Settings.AppOrientation = aoVertical then
    RotateApp(GenMenuF.Handle,aoVertical);
  if MainForm.Settings.AppOrientation = aoHorizontal then
    RotateApp(GenMenuF.Handle,aoHorizontal);
end;

procedure TGenMenuF.FormCloseQuery(Sender: TObject; var CanClose: boolean);
begin
  if ModalResult = mrOk then
    begin
      if ListBox1.ItemIndex > -1 then
        MRes := ListBox1.Items[ListBox1.ItemIndex]
      else
        MRes := '';
    end
  else
    MRes := '';
  CanClose := True;
end;

procedure TGenMenuF.FormMouseLeave(Sender: TObject);
begin
  MRes := '';
end;

procedure TGenMenuF.ListBox1MouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
begin
  Moving := True;
  Timer1.Enabled := True;
end;

procedure TGenMenuF.ListBox1MouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  if Moving then
    begin
      Moving := False;
    end
end;

end.

